<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' IssueExport CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' IssueExport CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "IssueExport.asp"
sTemplateFileName = "IssueExport.html"
'===============================


'===============================
' IssueExport PageSecurity begin
' IssueExport PageSecurity end
'===============================

'===============================
' IssueExport Open Event begin
'No Header or Footer needed
sHeaderFileName=""
sFooterFileName=""
'Change HTML header to specify Excel's MIME content type
Response.Contenttype="application/vnd.ms-excel"
' IssueExport Open Event end
'===============================


'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' IssueExport Show begin

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
Issues_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' IssueExport Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' IssueExport Close Event begin
' IssueExport Close Event end
'===============================

'===============================
' Display Grid Form
'-------------------------------
Sub Issues_Show()
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim rs
  Dim sWhere : sWhere = ""
  Dim sOrder : sOrder = ""
  Dim sSQL : sSQL = ""
  Dim sFormTitle: sFormTitle = "{issue_view}"
  Dim HasParam : HasParam = false
  Dim iTmpI : iTmpI = 0
  Dim iTmpJ : iTmpJ = 0
  Dim sCountSQL : sCountSQL = ""

  SetVar "TransitParams", "assigned_by=" & ToURL(GetParam("assigned_by")) & "&assigned_to=" & ToURL(GetParam("assigned_to")) & "&issue_name=" & ToURL(GetParam("issue_name")) & "&priority_id=" & ToURL(GetParam("priority_id")) & "&status_id=" & ToURL(GetParam("status_id")) & "&"
  SetVar "FormParams", "assigned_by=" & ToURL(GetParam("assigned_by")) & "&assigned_to=" & ToURL(GetParam("assigned_to")) & "&issue_name=" & ToURL(GetParam("issue_name")) & "&notstatus_id=" & ToURL(GetParam("notstatus_id")) & "&priority_id=" & ToURL(GetParam("priority_id")) & "&status_id=" & ToURL(GetParam("status_id")) & "&"

'-------------------------------
' Build WHERE statement
'-------------------------------
  passigned_by = GetParam("assigned_by")
  if IsNumeric(passigned_by) and not isEmpty(passigned_by) then passigned_by = ToSQL(passigned_by, "Number") else passigned_by = Empty
  if not isEmpty(passigned_by) then
    HasParam = true
    sWhere = sWhere & "i.[user_id]=" & passigned_by
  end if
  passigned_to = GetParam("assigned_to")
  if IsNumeric(passigned_to) and not isEmpty(passigned_to) then passigned_to = ToSQL(passigned_to, "Number") else passigned_to = Empty
  if not isEmpty(passigned_to) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[assigned_to]=" & passigned_to
  end if
  pissue_name = GetParam("issue_name")
  if not isEmpty(pissue_name) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[issue_desc] like '%" & replace(pissue_name, "'", "''") & "%'"
  end if
  pnotstatus_id = GetParam("notstatus_id")
  if IsNumeric(pnotstatus_id) and not isEmpty(pnotstatus_id) then pnotstatus_id = ToSQL(pnotstatus_id, "Number") else pnotstatus_id = Empty
  if not isEmpty(pnotstatus_id) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[status_id]<>" & pnotstatus_id
  end if
  ppriority_id = GetParam("priority_id")
  if IsNumeric(ppriority_id) and not isEmpty(ppriority_id) then ppriority_id = ToSQL(ppriority_id, "Number") else ppriority_id = Empty
  if not isEmpty(ppriority_id) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[priority_id]=" & ppriority_id
  end if
  pstatus_id = GetParam("status_id")
  if IsNumeric(pstatus_id) and not isEmpty(pstatus_id) then pstatus_id = ToSQL(pstatus_id, "Number") else pstatus_id = Empty
  if not isEmpty(pstatus_id) then
    if not (sWhere = "") then sWhere = sWhere & " and "
    HasParam = true
    sWhere = sWhere & "i.[status_id]=" & pstatus_id
  end if


  if HasParam then
    sWhere = " WHERE (" & sWhere & ")"
  end if
  
'-------------------------------
' Build ORDER BY statement
'-------------------------------
  sOrder = " order by i.issue_id Asc"

'-------------------------------
' Build base SQL statement
'-------------------------------
  sSQL = "select [i].[approved] as i_approved, " & _
    "[i].[assigned_to] as i_assigned_to, " & _
    "[i].[assigned_to_orig] as i_assigned_to_orig, " & _
    "[i].[date_modified] as i_date_modified, " & _
    "[i].[date_submitted] as i_date_submitted, " & _
    "[i].[issue_desc] as i_issue_desc, " & _
    "[i].[issue_id] as i_issue_id, " & _
    "[i].[issue_name] as i_issue_name, " & _
    "[i].[modified_by] as i_modified_by, " & _
    "[i].[priority_id] as i_priority_id, " & _
    "[i].[status_id] as i_status_id, " & _
    "[i].[tested] as i_tested, " & _
    "[i].[user_id] as i_user_id, " & _
    "[i].[version] as i_version, " & _
    "[s].[status_id] as s_status_id, " & _
    "[s].[status] as s_status, " & _
    "[p].[priority_id] as p_priority_id, " & _
    "[p].[priority_desc] as p_priority_desc, " & _
    "[u].[user_id] as u_user_id, " & _
    "[u].[user_name] as u_user_name, " & _
    "[u1].[user_id] as u1_user_id, " & _
    "[u1].[user_name] as u1_user_name, " & _
    "[u2].[user_id] as u2_user_id, " & _
    "[u2].[user_name] as u2_user_name, " & _
    "[u3].[user_id] as u3_user_id, " & _
    "[u3].[user_name] as u3_user_name " & _
    " from (((((([issues] i left join [statuses] s on [s].[status_id]=i.[status_id]) left join [priorities] p on [p].[priority_id]=i.[priority_id]) left join [users] u on [u].[user_id]=i.[user_id]) left join [users] u1 on [u1].[user_id]=i.[assigned_to_orig]) left join [users] u2 on [u2].[user_id]=i.[assigned_to]) left join [users] u3 on [u3].[user_id]=i.[modified_by]) "
'-------------------------------

'-------------------------------
' Issues Open Event begin
'Show Status of Shown Issues

param_status = GetParam("status_id")
param_notstatus = GetParam("notstatus_id")
if param_notstatus = "0" then param_notstatus = ""

if param_notstatus<>"" then
  issue_look = DLookup("statuses","status","status_id=" & param_notstatus)
  issue_view = "Issues that are not " & issue_look
end if
if param_status<>"" then
  issue_look = DLookup("statuses","status","status_id=" & param_status)
  issue_view = issue_look & " Issues"
end if
if param_status="" and param_notstatus="" then
  issue_view = "All Issues"
end if

SetVar "issue_view",issue_view

'If no param, show only issues that are not-Closed
'if HasParam then
'else
'  sWhere = " WHERE [s].[status_id]<>3"
'end if
' Issues Open Event end
'-------------------------------

'-------------------------------
' Assemble full SQL statement
'-------------------------------
  sSQL = sSQL & sWhere & sOrder
  if sCountSQL = "" then
    iTmpI = instr(lcase(sSQL), "select")
    iTmpJ = instr(lcase(sSQL), "from") - 1
    sCountSQL = replace(sSQL, mid(sSQL, iTmpI + 6, iTmpJ - 6), " count(*) ")
    iTmpI = instr(lcase(sCountSQl), "order by")
    if iTmpI > 1 then sCountSQL = left(sCountSQL, iTmpI - 1)
  end if
'-------------------------------

SetVar "FormTitle", sFormTitle

'-------------------------------
' Open the recordset
'-------------------------------
  openStaticRS rs, sSQL
'-------------------------------

'-------------------------------
' Process empty recordset
'-------------------------------
  if rs.eof then
    set rs = nothing
    SetVar "DListIssues", ""
    Parse "IssuesNoRecords", False
    Parse "FormIssues", False
    exit sub
  end if
'-------------------------------

'-------------------------------
' Prepare the lists of values
'-------------------------------

  atested = Split("1;Yes", ";")
  aapproved = Split("1;Yes", ";")
'-------------------------------

'-------------------------------
' Display grid based on recordset
'-------------------------------
  while not rs.EOF 
'-------------------------------
' Create field variables based on database fields
'-------------------------------
    fldapproved = GetValue(rs, "i_approved")
    fldassigned_to = GetValue(rs, "u2_user_name")
    fldassigned_to_orig = GetValue(rs, "u1_user_name")
    flddate_modified = GetValue(rs, "i_date_modified")
    flddate_submitted = GetValue(rs, "i_date_submitted")
    fldissue_desc = GetValue(rs, "i_issue_desc")
    fldissue_id = GetValue(rs, "i_issue_id")
    fldissue_name = GetValue(rs, "i_issue_name")
    fldmodified_by = GetValue(rs, "u3_user_name")
    fldpriority_id = GetValue(rs, "p_priority_desc")
    fldstatus_id = GetValue(rs, "s_status")
    fldtested = GetValue(rs, "i_tested")
    flduser_id = GetValue(rs, "u_user_name")
    fldversion = GetValue(rs, "i_version")
'-------------------------------
' Issues Show begin
'-------------------------------

'-------------------------------
' Issues Show Event begin
if fldpriority_id = "High" then fldpriority_id = "<font color=""blue""><b>" & fldpriority_id & "</b></font>"
if fldpriority_id = "Highest" then fldpriority_id = "<font color=""red""><b>" & fldpriority_id & "</b></font>"

if fldassigned_to = DLookup("users","user_name",Session("UserID")) then fldassigned_to= "<font color=""red"">" & fldassigned_to & "</font>"
' Issues Show Event end
'-------------------------------

'-------------------------------
' Replace Template fields with database values
'-------------------------------
    
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "issue_name", ToHTML(fldissue_name)
      SetVar "issue_desc", ToHTML(fldissue_desc)
      SetVar "status_id", ToHTML(fldstatus_id)
      SetVar "priority_id", fldpriority_id
      SetVar "user_id", ToHTML(flduser_id)
      SetVar "date_submitted", ToHTML(flddate_submitted)
      SetVar "assigned_to_orig", ToHTML(fldassigned_to_orig)
      SetVar "assigned_to", fldassigned_to
      SetVar "modified_by", ToHTML(fldmodified_by)
      SetVar "date_modified", ToHTML(flddate_modified)
      fldtested = getValFromLOV(fldtested, atested)
      SetVar "tested", ToHTML(fldtested)
      fldapproved = getValFromLOV(fldapproved, aapproved)
      SetVar "approved", ToHTML(fldapproved)
      SetVar "version", ToHTML(fldversion)
    Parse "DListIssues", True

'-------------------------------
' Issues Show end
'-------------------------------

'-------------------------------
' Move to the next record 
'-------------------------------
    rs.MoveNext
  wend
'-------------------------------


'-------------------------------
' Finish form processing
'-------------------------------
  set rs = nothing
  SetVar "IssuesNoRecords", ""
  Parse "FormIssues", False

'-------------------------------
' Issues Close Event begin
' Issues Close Event end
'-------------------------------
End Sub
'===============================

%>